# Enum Class AccessFlag.Location

java.lang.Object
java.lang.Enum<AccessFlag.Location>
java.lang.reflect.AccessFlag.Location

All Implemented Interfaces:
  `Serializable, Comparable<AccessFlag.Location>, Constable`

Enclosing class:
  `AccessFlag`

public static enum AccessFlag.Location extends Enum<AccessFlag.Location>
A location within a `class` file where flags can be applied.

Note that since these locations represent `class` file structures rather than language structures, many language structures, such as constructors and interfaces, are not present.

Since:
  20

## Nested Class Summary

### Nested classes/interfaces declared in class Enum

`Enum.EnumDesc<E>`
Modifier and Type
Class
Description
`static final class`
`Enum.EnumDesc<E extends Enum<E>>`
A nominal descriptor for an `enum` constant.

## Enum Constant Summary

Enum Constants
Enum Constant
Description
`CLASS`
Class location.
`FIELD`
Field location.
`INNER_CLASS`
Inner class location.
`METHOD`
Method location.
`METHOD_PARAMETER`
Method parameter location.
`MODULE`
Module location.
`MODULE_EXPORTS`
Module exports location.
`MODULE_OPENS`
Module opens location.
`MODULE_REQUIRES`
Module requires location.

## Method Summary

Modifier and Type
Method
Description
`Set<AccessFlag>`
`flags()`
Returns the set of access flags defined for this location in the current class file format version.
`Set<AccessFlag>`
`flags(ClassFileFormatVersion cffv)`
Returns the set of access flags defined for this location in the given class file format version.
`int`
`flagsMask()`
Returns the union of masks of all access flags defined for this location in the current class file format version.
`int`
`flagsMask(ClassFileFormatVersion cffv)`
Returns the union of masks of all access flags defined for this location in the given class file format version.
`static AccessFlag.Location`
`valueOf(String name)`
Returns the enum constant of this class with the specified name.
`static AccessFlag.Location[]`
`values()`
Returns an array containing the constants of this enum class, in the order they are declared.

### Methods declared in class Enum

`clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`
Modifier and Type
Method
Description
`protected final Object`
`clone()`
Throws CloneNotSupportedException.
`final int`
`compareTo(AccessFlag.Location o)`
Compares this enum with the specified object for order.
`final Optional<Enum.EnumDesc<AccessFlag.Location>>`
`describeConstable()`
Returns an enum descriptor `EnumDesc` for this instance, if one can be constructed, or an empty `Optional` if one cannot be.
`final boolean`
`equals(Object other)`
Returns true if the specified object is equal to this enum constant.
`protected final void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization has been deprecated for removal.
`final Class<AccessFlag.Location>`
`getDeclaringClass()`
Returns the Class object corresponding to this enum constant's enum type.
`final int`
`hashCode()`
Returns a hash code for this enum constant.
`final String`
`name()`
Returns the name of this enum constant, exactly as declared in its enum declaration.
`final int`
`ordinal()`
Returns the ordinal of this enumeration constant (its position in its enum declaration, where the initial constant is assigned an ordinal of zero).
`String`
`toString()`
Returns the name of this enum constant, as contained in the declaration.
`static <T extends Enum<T>>
T`
`valueOf(Class<T> enumClass, String name)`
Returns the enum constant of the specified enum class with the specified name.

### Methods declared in class Object

`getClass, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Enum Constant Details

### CLASS

public static final AccessFlag.Location CLASS
Class location.

See Java Virtual Machine Specification:
  4.1 The `ClassFile` Structure
See Also:
  - `Class.accessFlags()`
  - `ClassModel.flags()`
  - `Modifier.classModifiers()`
  - `Modifier.interfaceModifiers()`

### FIELD

public static final AccessFlag.Location FIELD
Field location.

See Java Virtual Machine Specification:
  4.5 Fields
See Also:
  - `Field.accessFlags()`
  - `FieldModel.flags()`
  - `Modifier.fieldModifiers()`

### METHOD

public static final AccessFlag.Location METHOD
Method location.

See Java Virtual Machine Specification:
  4.6 Methods
See Also:
  - `Executable.accessFlags()`
  - `MethodModel.flags()`
  - `Modifier.methodModifiers()`
  - `Modifier.constructorModifiers()`

### INNER_CLASS

public static final AccessFlag.Location INNER_CLASS
Inner class location.

See Java Virtual Machine Specification:
  4.7.6 The `InnerClasses` Attribute
See Also:
  - `Class.accessFlags()`
  - `InnerClassInfo.flags()`
  - `Modifier.classModifiers()`
  - `Modifier.interfaceModifiers()`

### METHOD_PARAMETER

public static final AccessFlag.Location METHOD_PARAMETER
Method parameter location.

See Java Virtual Machine Specification:
  4.7.24 The `MethodParameters` Attribute
See Also:
  - `Parameter.accessFlags()`
  - `MethodParameterInfo.flags()`
  - `Modifier.parameterModifiers()`

### MODULE

public static final AccessFlag.Location MODULE
Module location.

See Java Virtual Machine Specification:
  4.7.25 The `Module` Attribute
See Also:
  - `ModuleDescriptor.accessFlags()`
  - `ModuleAttribute.moduleFlags()`

### MODULE_REQUIRES

public static final AccessFlag.Location MODULE_REQUIRES
Module requires location.

See Java Virtual Machine Specification:
  4.7.25 The `Module` Attribute
See Also:
  - `ModuleDescriptor.Requires.accessFlags()`
  - `ModuleRequireInfo.requiresFlags()`

### MODULE_EXPORTS

public static final AccessFlag.Location MODULE_EXPORTS
Module exports location.

See Java Virtual Machine Specification:
  4.7.25 The `Module` Attribute
See Also:
  - `ModuleDescriptor.Exports.accessFlags()`
  - `ModuleExportInfo.exportsFlags()`

### MODULE_OPENS

public static final AccessFlag.Location MODULE_OPENS
Module opens location.

See Java Virtual Machine Specification:
  4.7.25 The `Module` Attribute
See Also:
  - `ModuleDescriptor.Opens.accessFlags()`
  - `ModuleOpenInfo.opensFlags()`

## Method Details

### values

public static AccessFlag.Location[] values()
Returns an array containing the constants of this enum class, in the order they are declared.

Returns:
  an array containing the constants of this enum class, in the order they are declared

### valueOf

public static AccessFlag.Location valueOf(String name)
Returns the enum constant of this class with the specified name. The string must match exactly an identifier used to declare an enum constant in this class. (Extraneous whitespace characters are not permitted.)

Parameters:
  `name` - the name of the enum constant to be returned.
Returns:
  the enum constant with the specified name
Throws:
  `IllegalArgumentException` - if this enum class has no constant with the specified name
  `NullPointerException` - if the argument is null

### flagsMask

public int flagsMask()
Returns the union of masks of all access flags defined for this location in the current class file format version.

This method returns `0` if this location does not exist in the current class file format version.

Returns:
  the union of masks of all access flags defined for this location in the current class file format version
Since:
  25

### flagsMask

public int flagsMask(ClassFileFormatVersion cffv)
Returns the union of masks of all access flags defined for this location in the given class file format version.

This method returns `0` if this location does not exist in the given `cffv`.

Parameters:
  `cffv` - the class file format version
Returns:
  the union of masks of all access flags defined for this location in the given class file format version
Throws:
  `NullPointerException` - if `cffv` is `null`
Since:
  25

### flags

public Set<AccessFlag> flags()
Returns the set of access flags defined for this location in the current class file format version. The set is immutable.

This method returns an empty set if this location does not exist in the current class file format version.

Returns:
  the set of access flags defined for this location in the current class file format version
Since:
  25

### flags

public Set<AccessFlag> flags(ClassFileFormatVersion cffv)
Returns the set of access flags defined for this location in the given class file format version. The set is immutable.

This method returns an empty set if this location does not exist in the given `cffv`.

Parameters:
  `cffv` - the class file format version
Returns:
  the set of access flags defined for this location in the given class file format version
Throws:
  `NullPointerException` - if `cffv` is `null`
Since:
  25